Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp	(revision 1520)
@@ -9,153 +9,195 @@
   int MPI_Comm_free(MPI_Comm *comm)
   {
-    if(! comm->is_ep)
-    {
-      if(comm->mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
-      {
-        ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
-
-        ::MPI_Comm_free(&mpi_comm);
-        Debug("comm is MPI, freed\n");
-      }
-      return 0;
-    }
-
-    else if(comm->is_intercomm)
-    {
-      return MPI_Comm_free_intercomm(comm);
-    }
-
-    else
-    {
-      int ep_rank_loc, num_ep;
-
-      ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
-      num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
-
-      MPI_Barrier(*comm);
-
-      if(ep_rank_loc == 0)
-      {
-        Debug("comm is EP, mpi_comm_ptr != NULL\n");
-
-        delete comm->my_buffer;
-
-
-        if(comm->ep_barrier != NULL)
-        {
-          comm->ep_barrier->~OMPbarrier();
-          Debug("ep_barrier freed\n");
-        }
-
-
-        if( ! comm->rank_map->empty() )
-        {
-          comm->rank_map->clear();
-          Debug("rank_map emptied\n");
-        }
-
-        for(int i=0; i<num_ep; i++)
-        {
-          comm->ep_comm_ptr->comm_list[i].ep_comm_ptr->message_queue->clear();
-          Debug("message queue freed\n");
-          
-
-          if(comm->ep_comm_ptr->comm_list[i].ep_comm_ptr != NULL)
-          {
-            delete comm->ep_comm_ptr->comm_list[i].ep_comm_ptr;
-            Debug("ep_comm_ptr freed\n");
-          }
-        }
-
-        if( to_mpi_comm(comm->mpi_comm) != *static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm) 
-          && to_mpi_comm(comm->mpi_comm) != *static_cast< ::MPI_Comm*>(MPI_COMM_WORLD.mpi_comm))
-        {
-          ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
-          ::MPI_Comm_free(&mpi_comm);
-          Debug("mpi_comm freed\n");
-        }
-
-       if(comm != NULL) {delete[] comm->ep_comm_ptr->comm_list; Debug("comm freed\n");}
-
-      }
-
-      return 0;
-    }
-
-
-
-  }
-
-  int MPI_Comm_free_intercomm(MPI_Comm *comm)
-  {
+    if(! (*comm)->is_ep)
+    {
+      return MPI_Comm_free_mpi(comm);
+    }
+
+    else 
+    {
+      if((*comm)->is_intercomm)
+        return MPI_Comm_free_intercomm(comm);
+      else
+        return MPI_Comm_free_intracomm(comm);
+    }
+  }
+
+
+
+  int MPI_Comm_free_mpi(MPI_Comm *comm)
+  {
+    Debug("MPI_Comm_free with MPI\n");
+
+    return ::MPI_Comm_free(to_mpi_comm_ptr((*comm)->mpi_comm));
+    
+  }
+
+  int MPI_Comm_free_intracomm(MPI_Comm *comm)
+  {
+    Debug("MPI_Comm_free with EP_intracomm\n");
+
     int ep_rank_loc, num_ep;
 
-    ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
-    num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
-
-    //MPI_Barrier(*comm);
+    ep_rank_loc = (*comm)->ep_comm_ptr->size_rank_info[1].first;
+    num_ep = (*comm)->ep_comm_ptr->size_rank_info[1].second;
+
+    MPI_Barrier(*comm);
 
     if(ep_rank_loc == 0)
     {
-      Debug("comm is EP, mpi_comm_ptr != NULL\n");
-
-
-      if(comm->ep_barrier != NULL)
-      {
-        comm->ep_barrier->~OMPbarrier();
-        Debug("ep_barrier freed\n");
-      }
-
-
-      if( ! comm->rank_map->empty() )
-      {
-        comm->rank_map->clear();
-        Debug("rank_map emptied\n");
-      }
+
+#ifdef _showinfo
+      printf("delete (*comm)->my_buffer = %p\n", (*comm)->my_buffer);
+#endif
+      delete (*comm)->my_buffer;
+
+
+      
+#ifdef _showinfo        
+      printf("delete (*comm)->ep_barrier = %p\n", (*comm)->ep_barrier);
+#endif
+      delete (*comm)->ep_barrier;
+      
+
+
+      (*comm)->ep_rank_map->clear();
+#ifdef _showinfo
+      printf("delete (*comm)->ep_rank_map = %p\n", (*comm)->ep_rank_map);
+#endif
+      delete (*comm)->ep_rank_map;
+      
 
       for(int i=0; i<num_ep; i++)
       {
-        comm->ep_comm_ptr->comm_list[i].ep_comm_ptr->message_queue->clear();
-        Debug("message queue freed\n");
-
-        #pragma omp critical (memory_free)
-        if(comm->ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm != NULL)
-        {
-          comm->ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->local_rank_map->clear();
-          comm->ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->remote_rank_map->clear();
-          comm->ep_comm_ptr->comm_list[i].ep_comm_ptr->intercomm->intercomm_rank_map->clear();
-          Debug("intercomm local/remote/intercomm_rank_map emptied\n");
-        }  
-
-        if(comm->ep_comm_ptr->comm_list[i].ep_comm_ptr != NULL)
-        {
-          delete comm->ep_comm_ptr->comm_list[i].ep_comm_ptr;
-          Debug("ep_comm_ptr freed\n");
-        }
+        (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue->clear();
+#ifdef _showinfo
+        printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->ep_comm_ptr->message_queue = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue);
+#endif
+        delete (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue;
+          
+
+#ifdef _showinfo
+        printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->ep_comm_ptr = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr);
+#endif
+        delete (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr;
+
+
+#ifdef _showinfo
+        printf("delete (*comm)->ep_comm_ptr->comm_list[%d] = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]);
+#endif
+        delete (*comm)->ep_comm_ptr->comm_list[i];
       }
 
-      if(comm->mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
+#ifdef _showinfo
+      printf("delete (*comm)->mpi_comm = %p\n", (*comm)->mpi_comm);
+#endif
+      ::MPI_Comm_free(to_mpi_comm_ptr((*comm)->mpi_comm));
+      
+#ifdef _showinfo
+      printf("delete (*comm)->ep_comm_ptr->comm_list = %p\n", (*comm)->ep_comm_ptr->comm_list);
+#endif
+      delete[] (*comm)->ep_comm_ptr->comm_list;
+    }
+  }
+
+
+
+
+
+
+
+  int MPI_Comm_free_intercomm(MPI_Comm *comm)
+  {
+    int ep_rank;
+    MPI_Comm_rank(*comm, &ep_rank);
+    int ep_rank_loc = (*comm)->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep =      (*comm)->ep_comm_ptr->size_rank_info[1].second;
+    
+    int newcomm_ep_rank =(*comm)->ep_comm_ptr->intercomm->size_rank_info[0].first; 
+    int newcomm_ep_rank_loc = (*comm)->ep_comm_ptr->intercomm->size_rank_info[1].first;
+    int newcomm_num_ep = (*comm)->ep_comm_ptr->intercomm->size_rank_info[1].second;
+
+    MPI_Barrier(*comm);
+
+    if(ep_rank_loc == 0)
+    {
+      (*comm)->ep_comm_ptr->intercomm->intercomm_rank_map->clear();
+#ifdef _showinfo
+      printf("delete (*comm)->ep_comm_ptr->intercomm->intercomm_rank_map = %p\n", (*comm)->ep_comm_ptr->intercomm->intercomm_rank_map);
+#endif
+      delete (*comm)->ep_comm_ptr->intercomm->intercomm_rank_map;
+
+      (*comm)->ep_comm_ptr->intercomm->local_rank_map->clear();
+#ifdef _showinfo
+      printf("delete (*comm)->ep_comm_ptr->intercomm->local_rank_map = %p\n", (*comm)->ep_comm_ptr->intercomm->local_rank_map);
+#endif
+      delete (*comm)->ep_comm_ptr->intercomm->local_rank_map;
+    }
+
+    if(newcomm_ep_rank_loc == 0)
+    {
+
+#ifdef _showinfo
+      printf("delete (*comm)->my_buffer = %p\n", (*comm)->my_buffer);
+#endif
+      delete (*comm)->my_buffer;
+
+
+      
+#ifdef _showinfo        
+      printf("delete (*comm)->ep_barrier = %p\n", (*comm)->ep_barrier);
+#endif
+      delete (*comm)->ep_barrier;
+      
+
+      (*comm)->ep_rank_map->clear();
+#ifdef _showinfo
+      printf("delete (*comm)->ep_rank_map = %p\n", (*comm)->ep_rank_map);
+#endif
+      delete (*comm)->ep_rank_map;
+      
+#ifdef _showinfo
+      printf("delete (*comm)->ep_comm_ptr->intercomm->mpi_inter_comm = %p\n", (*comm)->ep_comm_ptr->intercomm->mpi_inter_comm);
+#endif
+      ::MPI_Comm_free(to_mpi_comm_ptr((*comm)->ep_comm_ptr->intercomm->mpi_inter_comm));
+
+      for(int i=0; i<newcomm_num_ep; i++)
       {
-        ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
-        ::MPI_Comm_free(&mpi_comm);
-        Debug("mpi_comm freed\n");
+        (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue->clear();
+#ifdef _showinfo
+        printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->ep_comm_ptr->message_queue = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue);
+#endif
+        delete (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->message_queue;
+
+#ifdef _showinfo
+        printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->ep_comm_ptr->intercomm = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm);
+#endif
+        delete (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr->intercomm;        
+          
+
+#ifdef _showinfo
+        printf("delete (*comm)->ep_comm_ptr->comm_list[%d]->ep_comm_ptr = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr);
+#endif
+        delete (*comm)->ep_comm_ptr->comm_list[i]->ep_comm_ptr;
+
+
+#ifdef _showinfo
+        printf("delete (*comm)->ep_comm_ptr->comm_list[%d] = %p\n", i, (*comm)->ep_comm_ptr->comm_list[i]);
+#endif
+        delete (*comm)->ep_comm_ptr->comm_list[i];
+
       }
 
-      if(comm->ep_comm_ptr->intercomm->mpi_inter_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
-      {
-        ::MPI_Comm mpi_comm = to_mpi_comm(comm->ep_comm_ptr->comm_list->ep_comm_ptr->intercomm->mpi_inter_comm);
-        ::MPI_Comm_free(&mpi_comm);
-        Debug("mpi_intercomm freed\n");
-      }
-
-     if(comm != NULL) {delete[] comm->ep_comm_ptr->comm_list; Debug("comm freed\n");}
-
-    }
-
-    
-    
-    return 0;
-  }
-
+#ifdef _showinfo
+      printf("delete (*comm)->mpi_comm = %p\n", (*comm)->mpi_comm);
+#endif
+      ::MPI_Comm_free(to_mpi_comm_ptr((*comm)->mpi_comm));
+      
+#ifdef _showinfo
+      printf("delete (*comm)->ep_comm_ptr->comm_list = %p\n", (*comm)->ep_comm_ptr->comm_list);
+#endif
+      delete[] (*comm)->ep_comm_ptr->comm_list;
+    }
+  }
 
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gather.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gather.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gather.cpp	(revision 1520)
@@ -23,9 +23,9 @@
     ::MPI_Type_get_extent(to_mpi_type(datatype), &lb, &datasize);
 
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
 
     #pragma omp critical (_gather)
-    comm.my_buffer->void_buffer[ep_rank_loc] = const_cast< void* >(sendbuf);
+    comm->my_buffer->void_buffer[ep_rank_loc] = const_cast< void* >(sendbuf);
 
     MPI_Barrier_local(comm);
@@ -34,5 +34,5 @@
     {
       for(int i=0; i<num_ep; i++)
-        memcpy(recvbuf + datasize * i * count, comm.my_buffer->void_buffer[i], datasize * count);
+        memcpy(recvbuf + datasize * i * count, comm->my_buffer->void_buffer[i], datasize * count);
 
       //printf("local_recvbuf = %d %d \n", static_cast<int*>(recvbuf)[0], static_cast<int*>(recvbuf)[1] );
@@ -44,21 +44,21 @@
   int MPI_Gather(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm)
   {
-    if(!comm.is_ep)
+    if(!comm->is_ep)
     {
       return ::MPI_Gather(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype),
-                   root, to_mpi_comm(comm.mpi_comm));
+                   root, to_mpi_comm(comm->mpi_comm));
     }
 
     assert(sendcount == recvcount && sendtype == recvtype);
 
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    int ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
-    int root_mpi_rank = comm.rank_map->at(root).second;
-    int root_ep_loc = comm.rank_map->at(root).first;
+    int root_mpi_rank = comm->ep_rank_map->at(root).second;
+    int root_ep_loc = comm->ep_rank_map->at(root).first;
 
     ::MPI_Aint datasize, lb;
@@ -90,5 +90,5 @@
       for(int i=0; i<ep_size; i++)
       {
-        recvcounts[comm.rank_map->at(i).second]+=sendcount;
+        recvcounts[comm->ep_rank_map->at(i).second]+=sendcount;
       }
 
@@ -96,5 +96,5 @@
         displs[i] = displs[i-1] + recvcounts[i-1];
 
-      ::MPI_Gatherv(local_recvbuf, sendcount*num_ep, to_mpi_type(sendtype), tmp_recvbuf, recvcounts.data(), displs.data(), to_mpi_type(recvtype), root_mpi_rank, to_mpi_comm(comm.mpi_comm));
+      ::MPI_Gatherv(local_recvbuf, sendcount*num_ep, to_mpi_type(sendtype), tmp_recvbuf, recvcounts.data(), displs.data(), to_mpi_type(recvtype), root_mpi_rank, to_mpi_comm(comm->mpi_comm));
     }   
 
@@ -111,5 +111,5 @@
       for(int i=0; i<ep_size; i++)
       {
-        offset = displs[comm.rank_map->at(i).second] + comm.rank_map->at(i).first * sendcount; 
+        offset = displs[comm->ep_rank_map->at(i).second] + comm->ep_rank_map->at(i).first * sendcount; 
         memcpy(recvbuf + i*sendcount*datasize, tmp_recvbuf+offset*datasize, sendcount*datasize);
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp	(revision 1520)
@@ -23,10 +23,10 @@
     ::MPI_Type_get_extent(to_mpi_type(datatype), &lb, &datasize);
 
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
 
 
     #pragma omp critical (_gatherv)
-    comm.my_buffer->void_buffer[ep_rank_loc] = const_cast< void* >(sendbuf);
+    comm->my_buffer->void_buffer[ep_rank_loc] = const_cast< void* >(sendbuf);
 
     MPI_Barrier_local(comm);
@@ -35,5 +35,5 @@
     {
       for(int i=0; i<num_ep; i++)
-        memcpy(recvbuf + datasize*displs[i], comm.my_buffer->void_buffer[i], datasize*recvcounts[i]);
+        memcpy(recvbuf + datasize*displs[i], comm->my_buffer->void_buffer[i], datasize*recvcounts[i]);
 
     }
@@ -46,8 +46,8 @@
   {
   
-    if(!comm.is_ep)
+    if(!comm->is_ep)
     {
       return ::MPI_Gatherv(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, const_cast<int*>(input_recvcounts), const_cast<int*>(input_displs),
-                    to_mpi_type(recvtype), root, to_mpi_comm(comm.mpi_comm));
+                    to_mpi_type(recvtype), root, to_mpi_comm(comm->mpi_comm));
     }
 
@@ -56,13 +56,13 @@
 
     
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    int ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
-    int root_mpi_rank = comm.rank_map->at(root).second;
-    int root_ep_loc = comm.rank_map->at(root).first;
+    int root_mpi_rank = comm->ep_rank_map->at(root).second;
+    int root_ep_loc = comm->ep_rank_map->at(root).first;
 
     ::MPI_Aint datasize, lb;
@@ -126,5 +126,5 @@
       for(int i=0; i<ep_size; i++)
       {
-        mpi_recvcounts[comm.rank_map->at(i).second]+=recvcounts[i];
+        mpi_recvcounts[comm->ep_rank_map->at(i).second]+=recvcounts[i];
       }
 
@@ -133,5 +133,5 @@
 
 
-      ::MPI_Gatherv(local_recvbuf, sendcount*num_ep, to_mpi_type(sendtype), tmp_recvbuf, mpi_recvcounts.data(), mpi_displs.data(), to_mpi_type(recvtype), root_mpi_rank, to_mpi_comm(comm.mpi_comm));
+      ::MPI_Gatherv(local_recvbuf, sendcount*num_ep, to_mpi_type(sendtype), tmp_recvbuf, mpi_recvcounts.data(), mpi_displs.data(), to_mpi_type(recvtype), root_mpi_rank, to_mpi_comm(comm->mpi_comm));
     }   
 
@@ -144,6 +144,6 @@
       {
         int extra = 0;
-        for(int j=0, k=0; j<ep_size, k<comm.rank_map->at(i).first; j++)
-          if(comm.rank_map->at(i).second == comm.rank_map->at(j).second)
+        for(int j=0, k=0; j<ep_size, k<comm->ep_rank_map->at(i).first; j++)
+          if(comm->ep_rank_map->at(i).second == comm->ep_rank_map->at(j).second)
           {
             extra += recvcounts[j];
@@ -151,5 +151,5 @@
           }  
 
-        offset = mpi_displs[comm.rank_map->at(i).second] +  extra;
+        offset = mpi_displs[comm->ep_rank_map->at(i).second] +  extra;
 
         memcpy(recvbuf+displs[i]*datasize, tmp_recvbuf+offset*datasize, recvcounts[i]*datasize);
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_init.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_init.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_init.cpp	(revision 1520)
@@ -11,34 +11,27 @@
   int MPI_Init_thread(int *argc, char*** argv, int required, int*provided)
   {
-    //printf("MPI_Init_thread\n");
+    Debug("MPI_Init_thread with EP/MPI\n");
 
-    int id = omp_get_thread_num();
-
-    if(id == 0)
+    if(omp_get_thread_num() == 0)
     {
       ::MPI_Init_thread(argc, argv, required, provided);
     }
-    return 0;
   }
 
   int MPI_Init(int *argc, char ***argv)
   {
-    //printf("MPI_init called\n");
-    int id = omp_get_thread_num();
+    Debug("MPI_Init with EP/MPI\n");
 
-    if(id == 0)
+    if(omp_get_thread_num() == 0)
     {
       ::MPI_Init(argc, argv);
     }
-  	return 0;
   }
 
   int MPI_Initialized(int *flag)
   {
-    //printf("MPI_initialized called\n");
+    Debug("MPI_Initialized with EP/MPI\n");
 
-    ::MPI_Initialized(flag);
-    
-    return 0;
+    return ::MPI_Initialized(flag);
   }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp	(revision 1520)
@@ -10,18 +10,55 @@
   int MPI_Intercomm_create(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm)
   {
-    assert(local_comm.is_ep);
+    assert(local_comm->is_ep);
 
     int ep_rank, ep_rank_loc, mpi_rank;
     int ep_size, num_ep, mpi_size;
 
-    ep_rank = local_comm.ep_comm_ptr->size_rank_info[0].first;
-    ep_rank_loc = local_comm.ep_comm_ptr->size_rank_info[1].first;
-    mpi_rank = local_comm.ep_comm_ptr->size_rank_info[2].first;
-    ep_size = local_comm.ep_comm_ptr->size_rank_info[0].second;
-    num_ep = local_comm.ep_comm_ptr->size_rank_info[1].second;
-    mpi_size = local_comm.ep_comm_ptr->size_rank_info[2].second;
+    ep_rank = local_comm->ep_comm_ptr->size_rank_info[0].first;
+    ep_rank_loc = local_comm->ep_comm_ptr->size_rank_info[1].first;
+    mpi_rank = local_comm->ep_comm_ptr->size_rank_info[2].first;
+    ep_size = local_comm->ep_comm_ptr->size_rank_info[0].second;
+    num_ep = local_comm->ep_comm_ptr->size_rank_info[1].second;
+    mpi_size = local_comm->ep_comm_ptr->size_rank_info[2].second;
 
 
     MPI_Barrier(local_comm);
+
+    int leader_ranks_in_peer[3];  // local_leader_rank_in_peer
+                                  // remote_leader_rank_in_peer
+                                  // size of peer
+
+    if(ep_rank == local_leader)
+    {
+      MPI_Comm_rank(peer_comm, &leader_ranks_in_peer[0]);
+      leader_ranks_in_peer[1] = remote_leader;
+      MPI_Comm_size(peer_comm, &leader_ranks_in_peer[2]);
+    }
+
+    MPI_Bcast(leader_ranks_in_peer, 3, MPI_INT, local_leader, local_comm);
+
+    if(leader_ranks_in_peer[0] != leader_ranks_in_peer[2])
+    {
+      Debug("calling MPI_Intercomm_create_kernel\n");
+      return MPI_Intercomm_create_kernel(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);
+    }
+
+    else
+    {
+      if(leader_ranks_in_peer[2] == 1)
+      {
+        Debug("calling MPI_Intercomm_create_unique\n");
+        return MPI_Intercomm_create_unique_leader(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm); 
+        
+      }
+      else
+      {
+        Debug("calling MPI_Intercomm_create_world\n");
+        return MPI_Intercomm_create_from_world(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);   
+      }
+      
+    }
+
+
 
 
@@ -61,6 +98,6 @@
       if( leader_ranks[1] * leader_ranks[4] == 1)
       {
-        if(ep_rank == local_leader) Debug("calling MPI_Intercomm_create_unique_leader\n");
-        local_comm.ep_comm_ptr->comm_label = -99;
+        if(ep_rank == local_leader) printf("calling MPI_Intercomm_create_unique_leader\n");
+        local_comm->ep_comm_ptr->comm_label = -99;
 
         return MPI_Intercomm_create_unique_leader(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);
@@ -77,9 +114,9 @@
             // change leader
             is_decider = true;
-            int target = local_comm.rank_map->at(local_leader).second;
+            int target = local_comm->ep_rank_map->at(local_leader).second;
             {
               for(int i=0; i<ep_size; i++)
               {
-                if(local_comm.rank_map->at(i).second != target && local_comm.rank_map->at(i).first == 0)
+                if(local_comm->ep_rank_map->at(i).second != target && local_comm->ep_rank_map->at(i).first == 0)
                 {
                   new_local_leader = i;
@@ -100,9 +137,9 @@
             // change leader
             is_decider = true;
-            int target = local_comm.rank_map->at(local_leader).second;
+            int target = local_comm->ep_rank_map->at(local_leader).second;
             {
               for(int i=0; i<ep_size; i++)
               {
-                if(local_comm.rank_map->at(i).second != target && local_comm.rank_map->at(i).first == 0)
+                if(local_comm->ep_rank_map->at(i).second != target && local_comm->ep_rank_map->at(i).first == 0)
                 {
                   new_local_leader = i;
@@ -146,5 +183,5 @@
         if(ep_rank == new_local_leader)
         {
-          ::MPI_Comm_rank(to_mpi_comm(MPI_COMM_WORLD.mpi_comm), &leader_in_world[0]);
+          ::MPI_Comm_rank(to_mpi_comm(MPI_COMM_WORLD->mpi_comm), &leader_in_world[0]);
         }
 
@@ -165,16 +202,14 @@
         MPI_Bcast(&leader_in_world[1], 1, MPI_INT, local_leader, local_comm);
 
-        local_comm.ep_comm_ptr->comm_label = tag;
-
-        if(ep_rank == local_leader) Debug("calling MPI_Intercomm_create_from_world\n");
-
-        return MPI_Intercomm_create_from_world(local_comm, new_local_leader, MPI_COMM_WORLD.mpi_comm, leader_in_world[1], new_tag_in_world, newintercomm);
+        local_comm->ep_comm_ptr->comm_label = tag;
+
+        if(ep_rank == local_leader) printf("calling MPI_Intercomm_create_from_world\n");
+
+        return MPI_Intercomm_create_from_world(local_comm, new_local_leader, MPI_COMM_WORLD->mpi_comm, leader_in_world[1], new_tag_in_world, newintercomm);
         
       }
     }
 
-    if(ep_rank == local_leader) Debug("calling MPI_Intercomm_create_kernel\n");
-
-    return MPI_Intercomm_create_kernel(local_comm, local_leader, peer_comm, remote_leader, tag, newintercomm);
+    
 
   }
@@ -183,12 +218,12 @@
   {
     *flag = false;
-    if(comm.is_ep)
-    {
-      *flag = comm.is_intercomm;
+    if(comm->is_ep)
+    {
+      *flag = comm->is_intercomm;
       return 0;
     } 
-    else if(comm.mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
-    {
-      ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
+    else if(comm->mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL->mpi_comm))
+    {
+      ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
       
       ::MPI_Comm_test_inter(mpi_comm, flag);
